//////////////////////license & copyright header///////////////////////
//                                                                   //
//              Java Cannery - jar management utility.               //
//                Copyright (c) 1998 by Kevin Kelley                 //
//                                                                   //
// This program is free software; you can redistribute it and/or     //
// modify it under the terms of the GNU General Public License as    //
// published by the Free Software Foundation; either version 2 of    //
// the License, or (at your option) any later version.               //
//                                                                   //
// This program is distributed in the hope that it will be useful,   //
// but WITHOUT ANY WARRANTY; without even the implied warranty of    //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     //
// GNU General Public License for more details.                      //
//                                                                   //
// You should have received a copy of the GNU General Public License //
// along with this program in the file 'gpl.html'; if not, write to  //
// the Free Software Foundation, Inc., 59 Temple Place - Suite 330,  //
// Boston, MA 02111-1307, USA, or contact the author:                //
//                                                                   //
//                       Kevin Kelley  <kelley@iguana.ruralnet.net>  //
//                                                                   //
////////////////////end license & copyright header/////////////////////
package starlight.cannery;
import java.awt.*;
import java.awt.event.*;
import starlight.ui.*;


public class HelpAboutDialog extends Dialog
  implements ActionListener, WindowListener, KeyListener {

static public String CLOSE = "Close";
static public String versionString = Resources.VersionString;

static String text[] = {
                           "Java Cannery",
                                "by",
                      "Starlight Software Co.",
            "http://www.ruralnet.net/~kelley/index.html",
                 "(version " + versionString + ")",
                                 "",
                   "This program is free software",
                "and is distributed under the terms",
                "of the GNU General Public License.",
           "View the file 'gpl.html' for more information."
};
static Font fonts[] = {
    new Font("Monospaced", Font.BOLD+Font.ITALIC, 28),
    new Font("SanSerif", Font.ITALIC, 12),
    new Font("Monospaced", Font.BOLD, 20),
    new Font("SanSerif", Font.PLAIN, 12),
    new Font("Serif", Font.BOLD, 14),
    null,
    new Font("SanSerif", Font.PLAIN, 12),
    new Font("SanSerif", Font.PLAIN, 12),
    new Font("SanSerif", Font.PLAIN, 12),
    new Font("SanSerif", Font.PLAIN, 12)
};
static Color colors[] = {
    new Color(  0,255,255), // lightBlue
    new Color(  0,  0,128), // navyBlue
    new Color(128,128,192), // mediumBlue
    new Color(  0,  0,128), // navyBlue
    new Color(  0,  0,128), // navyBlue
    null,
    new Color(  0,  0, 64), // midnightBlue
    new Color(  0,  0, 64), // midnightBlue
    new Color(  0,  0, 64), // midnightBlue
    new Color(  0,  0, 64)  // midnightBlue
};


private HelpAboutDialog(Frame parent, String title, boolean modal) {
    super(parent, title, modal);

    addWindowListener(this);
    addKeyListener(this);
    setTitle(title);
    setLayout(new BorderLayout(10, 10));

    Panel messagePanel = createMultiLinePanel(text, fonts, colors);
    add("Center", messagePanel);

    //Panel centerPanel = new Panel();
    //Canvas imageCanvas = new ImageCanvas(Resources.appIcon);
    //centerPanel.add(imageCanvas);
    //centerPanel.add(messagePanel);
    //add("Center", centerPanel);

    Panel buttonPanel = new Panel();
    Button button = new Button("Close");
    button.addActionListener(this);
    button.addKeyListener(this);
    buttonPanel.add(button);
    add("South", buttonPanel);

    pack();
}


//---------- ActionListener Implementation ---------------
public void actionPerformed(ActionEvent evt) {
    setVisible(false);
    dispose();
}
//---------- WindowListener Implementatons ---------------
public void windowClosing    (WindowEvent evt) { fireCloseRequested(); }
public void windowClosed     (WindowEvent evt) {}
public void windowDeiconified(WindowEvent evt) {}
public void windowIconified  (WindowEvent evt) {}
public void windowOpened     (WindowEvent evt) {}
public void windowActivated  (WindowEvent evt) {}
public void windowDeactivated(WindowEvent evt) {}

//---------- KeyListener Implementation ------------------
public void keyPressed(KeyEvent evt) {
    if((evt.getKeyCode() == KeyEvent.VK_ESCAPE)
    || (evt.getKeyCode() == KeyEvent.VK_ENTER )
    || (evt.getKeyCode() == KeyEvent.VK_SPACE ))
        fireCloseRequested();
}
public void keyReleased(KeyEvent evt) {}
public void keyTyped(KeyEvent evt) {}

private void fireCloseRequested() {
    actionPerformed(new ActionEvent
        (this, ActionEvent.ACTION_PERFORMED, CLOSE));
}

//---------- Private Methods -----------------------------
private Panel createMultiLinePanel(String[] text, Font[] fonts, Color[] colors) {
    Panel mainPanel = new Panel();
    GridBagLayout gbLayout = new GridBagLayout();
    mainPanel.setLayout(gbLayout);
    addMultilineString(text, fonts, colors, mainPanel);
    return mainPanel;
}
private void addMultilineString(String[] lines,
                                Font[] fonts,
                                Color[] colors,
                                Container container)
{
    GridBagConstraints constraints = getDefaultConstraints();
    GridBagLayout gbLayout = (GridBagLayout)container.getLayout();

    for (int i=0; i<lines.length; i++) {
        Label label = new Label(lines[i], Label.CENTER);
        if (fonts[i]!=null) label.setFont(fonts[i]);
        if (colors[i]!=null) label.setForeground(colors[i]);
        gbLayout.setConstraints(label, constraints);
        container.add(label);
    }
}
private GridBagConstraints getDefaultConstraints() {
    GridBagConstraints constraints = new GridBagConstraints();
    constraints.weightx  = 1.0;
    constraints.weighty  = 1.0;
    constraints.gridwidth = GridBagConstraints.REMAINDER;
    constraints.gridheight = 1;
    constraints.ipadx = 0;
    constraints.ipady = 0;
    constraints.insets   = new Insets(0,0,0,0);
    constraints.fill = GridBagConstraints.NONE;
    constraints.anchor = GridBagConstraints.CENTER;
    return constraints;
}
static private void centerWindow(Window win) {
    Dimension screenDim = Toolkit.getDefaultToolkit().getScreenSize();
    // If larger than screen, reduce window width or height
    if (screenDim.width < win.getSize().width) {
        win.setSize(screenDim.width, win.getSize().height);
    }
    if (screenDim.height < win.getSize().height) {
        win.setSize(win.getSize().width, screenDim.height);
    }
    // Center Frame, Dialogue or Window on screen
    int x = (screenDim.width - win.getSize().width) / 2;
    int y = (screenDim.height - win.getSize().height) / 2;
    win.setLocation(x, y);
}
static private void enforceMinimumSize(Component comp,
        int minWidth, int minHeight) {
    if (comp.getSize().width < minWidth) {
        comp.setSize(minWidth, comp.getSize().height);
    }
    if (comp.getSize().height < minHeight) {
        comp.setSize(comp.getSize().width, minHeight);
    }
}


static public void showDialog(Frame parent, String title, boolean modal) {
    HelpAboutDialog dialog = new HelpAboutDialog(parent, title, modal);

    enforceMinimumSize(dialog, 200, 100);
    centerWindow(dialog);

    dialog.setVisible(true);
}

static public void showTimedDialog(Frame parent, String title, boolean modal, int delay) {
    final HelpAboutDialog dialog = new HelpAboutDialog(parent, title, modal);
    final long delayMS = delay * 1000L;

    enforceMinimumSize(dialog, 200, 100);
    centerWindow(dialog);

    new Thread(new Runnable() {
        public void run() {
            long start = System.currentTimeMillis();
            long end = start + delayMS;
            while (System.currentTimeMillis() < end) {
                try { Thread.sleep(end - System.currentTimeMillis()); }
                catch (InterruptedException e) {}
            }
            if (dialog.isVisible()) {
                dialog.setVisible(false);
                dialog.dispose();
            }
        }
    }).start();
    dialog.setVisible(true);
}
}
