//////////////////////license & copyright header///////////////////////
//                                                                   //
//              Java Cannery - jar management utility.               //
//                Copyright (c) 1998 by Kevin Kelley                 //
//                                                                   //
// This program is free software; you can redistribute it and/or     //
// modify it under the terms of the GNU General Public License as    //
// published by the Free Software Foundation; either version 2 of    //
// the License, or (at your option) any later version.               //
//                                                                   //
// This program is distributed in the hope that it will be useful,   //
// but WITHOUT ANY WARRANTY; without even the implied warranty of    //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     //
// GNU General Public License for more details.                      //
//                                                                   //
// You should have received a copy of the GNU General Public License //
// along with this program in the file 'gpl.html'; if not, write to  //
// the Free Software Foundation, Inc., 59 Temple Place - Suite 330,  //
// Boston, MA 02111-1307, USA, or contact the author:                //
//                                                                   //
//                       Kevin Kelley  <kelley@iguana.ruralnet.net>  //
//                                                                   //
////////////////////end license & copyright header/////////////////////
package starlight.cannery;
import java.awt.*;
import java.awt.event.*;
import java.util.Hashtable;
import starlight.ui.cmd.*;
import starlight.ui.ImageButton;

public class MainToolBar extends Panel implements CommandInvoker {

private Hashtable buttons = new Hashtable();

protected ImageButton findButton(Command cmd) {
    return (ImageButton) buttons.get(cmd.fullName());
}
public void createButton(Command cmd) {
    Image img = Resources.getCommandImage(cmd.fullName());
    ImageButton btn = new ImageButton(cmd.commandName(), img, ImageButton.IMAGE_ABOVE);
    btn.setActionCommand(cmd.fullName());
    btn.enableFocusBorder(false);
    add(btn);
    buttons.put(cmd.fullName(), btn);
    cmd.registerInvoker(this);
    btn.addActionListener(cmd);
}
public void installCommand(Command cmd) { findButton(cmd).setVisible(true);  repaint(); }
public void  removeCommand(Command cmd) { findButton(cmd).setVisible(false); repaint(); }
public void  enableCommand(Command cmd) { findButton(cmd).makeEnabled();  }
public void disableCommand(Command cmd) { findButton(cmd).makeDisabled(); }


public MainToolBar() { this(FlowLayout.LEFT, 4, 4); }

public MainToolBar(int align, int hgap, int vgap) {
    setLayout(new FlowLayout(align, hgap, vgap));
}

public Insets getInsets() { return new Insets(4, 2, 4, 2); }

public void update(Graphics g) { paint(g); }
public void  paint(Graphics g) {
    int w = getSize().width;
    int h = getSize().height;
    int left   = getInsets().left;
    int right  = getInsets().right;
    int top    = getInsets().top;
    int bottom = getInsets().bottom;

    g.setColor(getBackground());
    g.fillRect(0,0,w,h);

    g.setColor(getBackground().darker());
    g.drawLine(left, top-1, w-left-right-1, top-1);
    g.drawLine(left, h-bottom-1, w-left-right-1, h-bottom-1);

    g.setColor(getBackground().brighter());
    g.drawLine(left, top, w-left-right-1, top);
    g.drawLine(left, h-bottom, w-left-right-1, h-bottom);

    super.paint(g); // lightweights
}
/*
Tooltip tooltip;
public void initTooltips() {
    if (tooltip == null)
        tooltip = new Tooltip(this);
}
private Component prevTip = null;
public boolean mouseDown (Event e, int x, int y) { tooltip.disable(); return false; }
public boolean mouseDrag (Event e, int x, int y) { tooltip.disable(); return false; }
public boolean mouseUp   (Event e, int x, int y) { tooltip.enable (); return false; }
public boolean mouseEnter(Event e, int x, int y) { if (e.target==this) tooltip.enable (); return false; }
public boolean mouseExit (Event e, int x, int y) { if (e.target==this) tooltip.disable(); return false; }
public boolean mouseMove (Event e, int x, int y) {
    if (e.target!=this) return false;
    Component c = (Component) locate(x, y);
    if ((c != null)
    && (c instanceof ImageButton)) {
        ImageButton button = (ImageButton) c;
        tooltip.setText(button.getLabel());
        tooltip.enable();
    } else {
        tooltip.setText("");
        tooltip.disable();
    }
    tooltip.wiggle(x,y);
    prevTip = c;
    return false;
} */
}
