//////////////////////license & copyright header///////////////////////
//                                                                   //
//                Copyright (c) 1998 by Kevin Kelley                 //
//                                                                   //
// This program is free software; you can redistribute it and/or     //
// modify it under the terms of the GNU General Public License as    //
// published by the Free Software Foundation; either version 2 of    //
// the License, or (at your option) any later version.               //
//                                                                   //
// This program is distributed in the hope that it will be useful,   //
// but WITHOUT ANY WARRANTY; without even the implied warranty of    //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     //
// GNU General Public License for more details.                      //
//                                                                   //
// You should have received a copy of the GNU General Public License //
// along with this program in the file 'gpl.html'; if not, write to  //
// the Free Software Foundation, Inc., 59 Temple Place - Suite 330,  //
// Boston, MA 02111-1307, USA, or contact the author:  Kevin Kelley  //
// (kelley@iguana.ruralnet.net).                                     //
//                                                                   //
////////////////////end license & copyright header/////////////////////
package starlight.dialog;
import java.awt.*;
import java.awt.event.*;
import starlight.ui.*;


public class SaveDiscardCancelDialog implements ActionListener {

static public final int INVALID = -1;
static public final int SAVE = 1;
static public final int DISCARD = 2;
static public final int CANCEL = 3;

static Image warnIcon = images.ImageLoader.loadImage("exclaim.gif");
static String SaveMsg = "Save";
static String DiscardMsg = "Discard";
static String CancelMsg = "Cancel";

int action = INVALID;

private SaveDiscardCancelDialog() {}

static public int ask(String warnMsg)
{
    SaveDiscardCancelDialog dlg = new SaveDiscardCancelDialog();
    dlg.displayDialog(warnMsg);

    return dlg.action;
}
void displayDialog(String msg) {
    MessageBox box = new MessageBox();
    box.setTitle("File Changed Dialog");
    box.useImageCanvas(new ImageCanvas(warnIcon));
    box.addChoice(SaveMsg);
    box.addChoice(DiscardMsg);
    box.addChoice(CancelMsg);
    box.setActionListener(this);

    box.ask(msg);  //starts dialog in new thread, and returns
}
public synchronized void actionPerformed(ActionEvent evt) {
    String command = evt.getActionCommand();

    if (SaveMsg.equals(command))
        action = SAVE;
    else if (DiscardMsg.equals(command))
        action = DISCARD;
    else action = CANCEL;
}

// Unit test.
public static void main(String args[]) {
    int what = SaveDiscardCancelDialog.ask("What'll we do?");
    switch (what) {
    case SaveDiscardCancelDialog.SAVE:
        System.out.println("Ok!  we'll save."); break;
    case SaveDiscardCancelDialog.DISCARD:
        System.out.println("Whoosh!  They're gone."); break;
    case SaveDiscardCancelDialog.CANCEL:
        System.out.println("Ouch!  not so hard, please."); break;
    default:
        System.out.println("That's a bug."); break;
    }
    System.exit(0);
}}
