//////////////////////license & copyright header///////////////////////
//                                                                   //
//              Java Cannery - jar management utility.               //
//                Copyright (c) 1998 by Kevin Kelley                 //
//                                                                   //
// This program is free software; you can redistribute it and/or     //
// modify it under the terms of the GNU General Public License as    //
// published by the Free Software Foundation; either version 2 of    //
// the License, or (at your option) any later version.               //
//                                                                   //
// This program is distributed in the hope that it will be useful,   //
// but WITHOUT ANY WARRANTY; without even the implied warranty of    //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     //
// GNU General Public License for more details.                      //
//                                                                   //
// You should have received a copy of the GNU General Public License //
// along with this program in the file 'gpl.html'; if not, write to  //
// the Free Software Foundation, Inc., 59 Temple Place - Suite 330,  //
// Boston, MA 02111-1307, USA, or contact the author:                //
//                                                                   //
//                       Kevin Kelley  <kelley@iguana.ruralnet.net>  //
//                                                                   //
////////////////////end license & copyright header/////////////////////
package starlight.java;

public class AccessFlags {

public AccessFlags(int flags) { this.flags = flags; }

public boolean isPublic      () { return isSet(flags, ACC_PUBLIC      ); }
public boolean isProtected   () { return isSet(flags, ACC_PROTECTED   ); }
public boolean isPrivate     () { return isSet(flags, ACC_PRIVATE     ); }
public boolean isStatic      () { return isSet(flags, ACC_STATIC      ); }
public boolean isAbstract    () { return isSet(flags, ACC_ABSTRACT    ); }
public boolean isFinal       () { return isSet(flags, ACC_FINAL       ); }
public boolean isSynchronized() { return isSet(flags, ACC_SYNCHRONIZED); }
public boolean isNative      () { return isSet(flags, ACC_NATIVE      ); }
public boolean isThreadSafe  () { return isSet(flags, ACC_VOLATILE    ); }
public boolean isVolatile    () { return isSet(flags, ACC_VOLATILE    ); }
public boolean isTransient   () { return isSet(flags, ACC_TRANSIENT   ); }
public boolean isInterface   () { return isSet(flags, ACC_INTERFACE   ); }

public static String toString(int flags) {
    String rtn = "";
    if (!isSet(flags,ACC_PUBLIC)
      &&!isSet(flags,ACC_PROTECTED)
      &&!isSet(flags,ACC_PRIVATE))      {if(rtn.length()>0) rtn+=" "; rtn+="local";       }
    if (isSet(flags, ACC_PUBLIC      )) {if(rtn.length()>0) rtn+=" "; rtn+="public";      }
    if (isSet(flags, ACC_PROTECTED   )) {if(rtn.length()>0) rtn+=" "; rtn+="protected";   }
    if (isSet(flags, ACC_PRIVATE     )) {if(rtn.length()>0) rtn+=" "; rtn+="private";     }
    if (isSet(flags, ACC_ABSTRACT    )) {if(rtn.length()>0) rtn+=" "; rtn+="abstract";    }
    if (isSet(flags, ACC_STATIC      )) {if(rtn.length()>0) rtn+=" "; rtn+="static";      }
    if (isSet(flags, ACC_FINAL       )) {if(rtn.length()>0) rtn+=" "; rtn+="final";       }
    if (isSet(flags, ACC_TRANSIENT   )) {if(rtn.length()>0) rtn+=" "; rtn+="transient";   }
    if (isSet(flags, ACC_VOLATILE    )) {if(rtn.length()>0) rtn+=" "; rtn+="volatile";    }
    if (isSet(flags, ACC_NATIVE      )) {if(rtn.length()>0) rtn+=" "; rtn+="native";      }
    if (isSet(flags, ACC_SYNCHRONIZED)) {if(rtn.length()>0) rtn+=" "; rtn+="synchronized";}
    if (isSet(flags, ACC_INTERFACE   )) {if(rtn.length()>0) rtn+=" "; rtn+="interface";   }
    return rtn;
}

private static boolean isSet(int flags, int mask) { return (flags & mask) == mask; }

private static final int ACC_PUBLIC        = 0x0001; 
private static final int ACC_PRIVATE       = 0x0002; 
private static final int ACC_PROTECTED     = 0x0004; 
private static final int ACC_STATIC        = 0x0008;
private static final int ACC_FINAL         = 0x0010;
private static final int ACC_SYNCHRONIZED  = 0x0020;
private static final int ACC_VOLATILE      = 0x0040; 
private static final int ACC_TRANSIENT     = 0x0080;
private static final int ACC_NATIVE        = 0x0100;
private static final int ACC_INTERFACE     = 0x0200;
private static final int ACC_ABSTRACT      = 0x0400;

private int flags;

}
