//////////////////////license & copyright header///////////////////////
//                                                                   //
//              Java Cannery - jar management utility.               //
//                Copyright (c) 1998 by Kevin Kelley                 //
//                                                                   //
// This program is free software; you can redistribute it and/or     //
// modify it under the terms of the GNU General Public License as    //
// published by the Free Software Foundation; either version 2 of    //
// the License, or (at your option) any later version.               //
//                                                                   //
// This program is distributed in the hope that it will be useful,   //
// but WITHOUT ANY WARRANTY; without even the implied warranty of    //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     //
// GNU General Public License for more details.                      //
//                                                                   //
// You should have received a copy of the GNU General Public License //
// along with this program in the file 'gpl.html'; if not, write to  //
// the Free Software Foundation, Inc., 59 Temple Place - Suite 330,  //
// Boston, MA 02111-1307, USA, or contact the author:                //
//                                                                   //
//                       Kevin Kelley  <kelley@iguana.ruralnet.net>  //
//                                                                   //
////////////////////end license & copyright header/////////////////////
package starlight.java;
import java.io.File;
import java.util.Enumeration;

/**
*   An environment is a set of classes that can be loaded
* and run.  The default environment uses directories to 
* represent packages, and allows for multiple directory
* roots, specified by the CLASSPATH environment variable.
*   It searches the roots in declared order.
*/
public interface Environment {

    long getLastModified(String qualName);

    byte[] getFileBytes(String qualName);

    Enumeration roots();

    ResourceTree getRoot(String name);

    public void loadRoot(ResourceTree root); 

    public void unloadRoot(ResourceTree root);
}
