//////////////////////license & copyright header///////////////////////
//                                                                   //
//              Java Cannery - jar management utility.               //
//                Copyright (c) 1998 by Kevin Kelley                 //
//                                                                   //
// This program is free software; you can redistribute it and/or     //
// modify it under the terms of the GNU General Public License as    //
// published by the Free Software Foundation; either version 2 of    //
// the License, or (at your option) any later version.               //
//                                                                   //
// This program is distributed in the hope that it will be useful,   //
// but WITHOUT ANY WARRANTY; without even the implied warranty of    //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     //
// GNU General Public License for more details.                      //
//                                                                   //
// You should have received a copy of the GNU General Public License //
// along with this program in the file 'gpl.html'; if not, write to  //
// the Free Software Foundation, Inc., 59 Temple Place - Suite 330,  //
// Boston, MA 02111-1307, USA, or contact the author:                //
//                                                                   //
//                       Kevin Kelley  <kelley@iguana.ruralnet.net>  //
//                                                                   //
////////////////////end license & copyright header/////////////////////
package starlight.java;
import java.io.*;
import java.util.*;
import starlight.util.Msg;

public class JDKEnvironment implements Environment{

Vector rootPackages = new Vector();

public JDKEnvironment() {
    loadRoots();
}
public long getLastModified(String qualName) {
    for (int i=0; i<rootPackages.size(); i++) {
        ResourceTree root = (ResourceTree) rootPackages.elementAt(i);
        if (root.contains(qualName))
            return root.lastModified(qualName);
    } return -1;
}
public byte[] getFileBytes(String qualName) {
    for (int i=0; i<rootPackages.size(); i++) {
        ResourceTree root = (ResourceTree) rootPackages.elementAt(i);
        if (root.contains(qualName))
            return root.getBytes(qualName);
    } return null;
}

/**
*   return an enumeration of ResourceTree
*/
public Enumeration roots() { return rootPackages.elements(); }

/**
*   return the ResourceTree with specified name
*/
public ResourceTree getRoot(String name) { 
    for (int i=0; i<rootPackages.size(); i++) {
        ResourceTree root = (ResourceTree) rootPackages.elementAt(i);
        if (name.equals(root.getName()))
            return root;
    } return null;
}

/**
*   load the ResourceTree.
*/
public void loadRoot(ResourceTree root) { 
    if (root != null) 
        rootPackages.addElement(root);
}

/**
*   unload the ResourceTree 
*/
public void unloadRoot(ResourceTree root) { 
    rootPackages.removeElement(root);
}

/**
*   load all the roots listed in the CLASSPATH environment, plus HOME.
*/
void loadRoots() {
    String sep = System.getProperty("path.separator"); 
    String path = System.getProperty("java.class.path");
    StringTokenizer izer = new StringTokenizer(path, sep);
    while (izer.hasMoreTokens()) { 
        String name = izer.nextToken();
        try {
            File root = new File(name);
            name = root.getCanonicalPath();
        } catch (IOException e) {}
        ResourceTree pr = ResourceTree.createFrom(name);
        if (pr != null) 
            rootPackages.addElement(pr);
    }
}}
