//////////////////////license & copyright header///////////////////////
//                                                                   //
//              Java Cannery - jar management utility.               //
//                Copyright (c) 1998 by Kevin Kelley                 //
//                                                                   //
// This program is free software; you can redistribute it and/or     //
// modify it under the terms of the GNU General Public License as    //
// published by the Free Software Foundation; either version 2 of    //
// the License, or (at your option) any later version.               //
//                                                                   //
// This program is distributed in the hope that it will be useful,   //
// but WITHOUT ANY WARRANTY; without even the implied warranty of    //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     //
// GNU General Public License for more details.                      //
//                                                                   //
// You should have received a copy of the GNU General Public License //
// along with this program in the file 'gpl.html'; if not, write to  //
// the Free Software Foundation, Inc., 59 Temple Place - Suite 330,  //
// Boston, MA 02111-1307, USA, or contact the author:                //
//                                                                   //
//                       Kevin Kelley  <kelley@iguana.ruralnet.net>  //
//                                                                   //
////////////////////end license & copyright header/////////////////////
package starlight.java;
import java.io.*;
import java.util.*;

public class Signature {
    private String typeName;
    boolean isBuiltInType;
    int arrayDim = 0;

    Signature() {}
    Signature(String s, boolean builtIn) { setTypeName(s); isBuiltInType = builtIn; }

    void setTypeName(String s) {
        typeName = s.replace('/', '.'); 
    }
    public String basicTypeName() { 
        int ix = typeName.indexOf('[');
        if (ix >= 0) return typeName.substring(0, ix);
        else         return typeName;
    }
    public boolean isBuiltIn() { return isBuiltInType; }
    public boolean isArray() { return arrayDim > 0; }


public static Signature createFrom(String s) {
    Signature sig = new Signature();
    switch (s.charAt(0)) {
        case 'B': sig.setTypeName("byte");    sig.isBuiltInType = true; break;
        case 'C': sig.setTypeName("char");    sig.isBuiltInType = true; break;
        case 'D': sig.setTypeName("double");  sig.isBuiltInType = true; break;
        case 'F': sig.setTypeName("float");   sig.isBuiltInType = true; break;
        case 'I': sig.setTypeName("int");     sig.isBuiltInType = true; break;
        case 'J': sig.setTypeName("long");    sig.isBuiltInType = true; break;
        case 'S': sig.setTypeName("short");   sig.isBuiltInType = true; break;
        case 'Z': sig.setTypeName("boolean"); sig.isBuiltInType = true; break;
        case 'V': sig.setTypeName("void");    sig.isBuiltInType = true; break;
        case '[': sig = createFrom(s.substring(1, s.length())); sig.typeName += "[]"; ++sig.arrayDim; break;
        case 'L': sig.setTypeName(s.substring(1, s.indexOf(';'))); sig.isBuiltInType = false; break;
        default : sig.setTypeName(s); break;
    } 
    return sig;
}
public String toString() { return typeName; }
}
