//////////////////////license & copyright header///////////////////////
//                                                                   //
//              Java Cannery - jar management utility.               //
//                Copyright (c) 1998 by Kevin Kelley                 //
//                                                                   //
// This program is free software; you can redistribute it and/or     //
// modify it under the terms of the GNU General Public License as    //
// published by the Free Software Foundation; either version 2 of    //
// the License, or (at your option) any later version.               //
//                                                                   //
// This program is distributed in the hope that it will be useful,   //
// but WITHOUT ANY WARRANTY; without even the implied warranty of    //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     //
// GNU General Public License for more details.                      //
//                                                                   //
// You should have received a copy of the GNU General Public License //
// along with this program in the file 'gpl.html'; if not, write to  //
// the Free Software Foundation, Inc., 59 Temple Place - Suite 330,  //
// Boston, MA 02111-1307, USA, or contact the author:                //
//                                                                   //
//                       Kevin Kelley  <kelley@iguana.ruralnet.net>  //
//                                                                   //
////////////////////end license & copyright header/////////////////////
package starlight.ui;

import java.awt.*;

public class DoubleBufferPanel extends Panel {

    Image offscreen;

    public void invalidate() {
        super.invalidate();
        if (offscreen!=null) offscreen.flush();
        offscreen = null;
    }

    public void update(Graphics g) {
        Dimension size = getSize();
        if (offscreen == null)
            offscreen = createImage((size.width <1)? 1: size.width,
                                    (size.height<1)? 1: size.height);

        Graphics og = offscreen.getGraphics();
        if (og != null) try {
            og.setClip(g.getClip());

            og.setColor(getBackground());
            og.fillRect(0, 0, size.width, size.height);

            super.paint(og);
        }
        finally  { og.dispose(); }

        paint(g);
    }

    public void  paint(Graphics g) {
        if (offscreen != null)
            g.drawImage(offscreen, 0, 0, null);
    }
}
